# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_card.ipynb.

# %% auto 0
__all__ = ['suits', 'ranks', 'Card']

# %% ../nbs/00_card.ipynb 3
from fastcore.utils import *

# %% ../nbs/00_card.ipynb 4
suits = ["♣️","♦️","❤️","♠️"]
ranks = [None, "A"] + [str(x) for x in range(2,11)]  + ["J", "Q", "K"]

# %% ../nbs/00_card.ipynb 12
class Card:
    "A playing card, created by passing a suit and rank"
    def __init__(self,
                  suit:int, # An index into `suits`
                  rank:int # An index into `ranks`
                  ): self.suit, self.rank = suit, rank
    def __repr__(self): return f"{ranks[self.rank]}{suits[self.suit]}"

    

# %% ../nbs/00_card.ipynb 15
@patch
def __eq__(self:Card, other:Card): return self.suit == other.suit and self.rank == other.rank

# %% ../nbs/00_card.ipynb 17
@patch
def __lt__(self:Card, other:Card): return (self.rank, self.suit) < (other.rank, other.suit)

# %% ../nbs/00_card.ipynb 19
@patch
def __gt__(self:Card, other:Card): return (self.rank, self.suit) > (other.rank, other.suit)
