# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/01_deck.ipynb.

# %% auto 0
__all__ = ['Deck', 'draw_n']

# %% ../nbs/01_deck.ipynb 2
from .card import *
from fastcore.utils import *
import random

# %% ../nbs/01_deck.ipynb 4
class Deck:
    def __init__(self): self.cards = [Card(s, r) for s in range(4) for r in range(1, 14)]
    def __len__(self): return len(self.cards)
    def __str__(self): return '; '.join(map(str, self.cards))
    def __contains__(self, card): return card in self.cards
    __repr__ = __str__

    def shuffle(self):
        "shuffles the cards in the deck"
        random.shuffle(self.cards)


# %% ../nbs/01_deck.ipynb 12
@patch
def pop(self:Deck, # The deck to pop from
        idx:int=-1): # The index of the card to remove, defaulting to the last one
    "Remove and return the last card in the deck"
    return self.cards.pop(idx)

# %% ../nbs/01_deck.ipynb 13
@patch
def remove(self:Deck, # The deck to pop from
        idx:int=-1): # The index of the card to remove, defaulting to the last one
    "Remove the last card in the deck or raise exception if it is not there"
    return self.cards.remove(idx)

# %% ../nbs/01_deck.ipynb 14
def draw_n(n:int, # number of cards to draw
           replace:bool=True): # whether or not draw with replacement
    "Draw `n` cards, with replacement iif `replace`"
    d = Deck()
    d.shuffle()
    if replace: return [d.cards[random.choice(range(len(d.cards)))] for _ in range(n)]
    else: return d.cards[:n]
